//+------------------------------------------------------------------+
//|                                                     Ichimoku.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color2 Blue
#property indicator_color1 Red
#property indicator_color3 SandyBrown
#property indicator_color4 Thistle
#property indicator_color5 Lime
#property indicator_color6 SandyBrown
#property indicator_color7 Thistle
#property indicator_color8 White
//---- input parameters
extern int Kijun1=26;
extern  bool K1=true;
extern int Kijun2=52;
extern bool K2=true;
extern int Kijun3=104;
extern bool K3=true;
extern int Kijun4=208;
extern bool K4=true;
//---- buffers
double Kijunl1_Buffer[];
double Kijunh1_Buffer[];
double Kijunl2_Buffer[];
double Kijunh2_Buffer[];
double Kijunl3_Buffer[];
double Kijunh3_Buffer[];
double Kijunl4_Buffer[];
double Kijunh4_Buffer[];
//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,Kijunl1_Buffer);
   SetIndexDrawBegin(0,Kijun1 - 1);
   SetIndexLabel(0,"Kijunl1 Sen");
//----
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,Kijunh1_Buffer);
   SetIndexDrawBegin(1,Kijun1-1);
   SetIndexLabel(1,"Kijunh1 Sen");
//----
//----
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(2,Kijunl2_Buffer);
   SetIndexDrawBegin(2,Kijun2-1);
   SetIndexLabel(0,"Kijunl2 Sen");
//----
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(3,Kijunh2_Buffer);
   SetIndexDrawBegin(3,Kijun2-1);
   SetIndexLabel(1,"Kijunh2 Sen");
//----
//----
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(4,Kijunl3_Buffer);
   SetIndexDrawBegin(4,Kijun3-1);
   SetIndexLabel(0,"Kijunl3 Sen");
//----
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(5,Kijunh3_Buffer);
   SetIndexDrawBegin(5,Kijun3-1);
   SetIndexLabel(1,"Kijunh3 Sen");
//----
//----
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(6,Kijunl4_Buffer);
   SetIndexDrawBegin(6,Kijun4-1);
   SetIndexLabel(0,"Kijunl4 Sen");
//----
   SetIndexStyle(7,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(7,Kijunh4_Buffer);
   SetIndexDrawBegin(7,Kijun4-1);
   SetIndexLabel(1,"Kijunh4 Sen");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Ichimoku Kinko Hyo                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;
//----
   if(Bars <= Kijun4 ) return(0);
//---- initial zero
   if(counted_bars < 1)
     {
      for(i=1;i<=Kijun1;i++)     Kijunl1_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun1;i++)     Kijunh1_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun2;i++)     Kijunl2_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun2;i++)     Kijunh2_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun3;i++)     Kijunl3_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun3;i++)     Kijunh3_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun4;i++)     Kijunl4_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun4;i++)     Kijunh4_Buffer[Bars-i]=0;
     }
////////////////////////////////////////////////////////////////////////
//---- Kijyunh1  
   if (K1 == true){
   i=Bars-Kijun1;
   if(counted_bars>Kijun1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i];  k=i-1+Kijun1;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         k--;
        }
      Kijunh1_Buffer[i]=high;
      i--;
     }
     }
//////////////////////////////////////////
//---- Kijyunl1  
   if (K1 == true){
   i=Bars-Kijun1;
   if(counted_bars>Kijun1 ) i=Bars-counted_bars-1;
   while(i>=0)
     {
      low=Low[i]; k=i-1+Kijun1;
      while(k>=i)
        {
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijunl1_Buffer[i]=low;
      i--;
     }
     }
////////////////////////////////////////////////////////////////////////
//---- Kijyunh2  
   if (K2 == true){
   i=Bars-Kijun2;
   if(counted_bars>Kijun2 && K2 == true) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i];  k=i-1+Kijun2;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         k--;
        }
      Kijunh2_Buffer[i]=high;
      i--;
     }
     }
//////////////////////////////////////////
//---- Kijyunl2  
   if (K2 == true){
   i=Bars-Kijun2;
   if(counted_bars>Kijun2  && K2 == true ) i=Bars-counted_bars-1;
   while(i>=0)
     {
      low=Low[i]; k=i-1+Kijun2;
      while(k>=i)
        {
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijunl2_Buffer[i]=low;
      i--;
     }
     }
////////////////////////////////////////////////////////////////////////
//---- Kijyunh3  
   if (K3 == true){
   i=Bars-Kijun3;
   if(counted_bars>Kijun3) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i];  k=i-1+Kijun3;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         k--;
        }
      Kijunh3_Buffer[i]=high;
      i--;
     }
     }
//////////////////////////////////////////
//---- Kijyunl3  
   if (K3 == true){
   i=Bars-Kijun3;
   if(counted_bars>Kijun3) i=Bars-counted_bars-1;
   while(i>=0)
     {
      low=Low[i]; k=i-1+Kijun3;
      while(k>=i)
        {
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijunl3_Buffer[i]=low;
      i--;
     }
     }
////////////////////////////////////////////////////////////////////////
//---- Kijyunh4  
   if (K4 == true){
   i=Bars-Kijun4;
   if(counted_bars>Kijun4) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i];  k=i-1+Kijun4;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         k--;
        }
      Kijunh4_Buffer[i]=high;
      i--;
     }
     }
//////////////////////////////////////////
//---- Kijyunl4  
   if (K4 == true){
   i=Bars-Kijun4;
   if(counted_bars>Kijun4) i=Bars-counted_bars-1;
   while(i>=0)
     {
      low=Low[i]; k=i-1+Kijun4;
      while(k>=i)
        {
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijunl4_Buffer[i]=low;
      i--;
     }
     }

////////////////////////////////////////////////////////////////////////
//----
   return(0);
  }
//+------------------------------------------------------------------+